import 'dart:async';

import 'package:nats/nats.dart';

StreamTransformer<String, String> messagesTransformer =
    StreamTransformer<String, String>.fromHandlers(
  handleData: (String data, EventSink<String> sink) {
    data
        .split(RegExp("((?=\\$OK)|(?=$INFO)|(?=$MSG)|(?=$PING)|(?=$PONG))"))
        .map((element) => element.trim())
        .where((element) => element.length > 0)
        .toList()
        .forEach((message) => sink.add(message));
  },
);
